Codeforces 337C:Quiz(贪心+规律+快速幂)

C. Quiz
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output

Manao is taking part in a quiz. The quiz consists of n consecutive questions. A correct answer gives one point to the player. The game also has a counter of consecutive correct answers. When the player answers a question correctly, the number on this counter increases by 1. If the player answers a question incorrectly, the counter is reset, that is, the number on it reduces to 0. If after an answer the counter reaches the number k, then it is reset, and the player's score is doubled. Note that in this case, first 1 point is added to the player's score, and then the total score is doubled. At the beginning of the game, both the player's score and the counter of consecutive correct answers are set to zero.

Manao remembers that he has answered exactly m questions correctly. But he does not remember the order in which the questions came. He's trying to figure out what his minimum score may be. Help him and compute the remainder of the corresponding number after division by 1000000009 (109 + 9).

Input

The single line contains three space-separated integers nm and k (2 ≤ k ≤ n ≤ 109; 0 ≤ m ≤ n).

Output

Print a single integer — the remainder from division of Manao's minimum possible score in the quiz by 1000000009 (109 + 9).

Examples
input
5 3 2
output
3
input
5 4 2
output
6
Note

Sample 1. Manao answered 3 questions out of 5, and his score would double for each two consecutive correct answers. If Manao had answered the first, third and fifth questions, he would have scored as much as 3 points.

Sample 2. Now Manao answered 4 questions. The minimum possible score is obtained when the only wrong answer is to the question 4.

Also note that you are asked to minimize the score and not the remainder of the score modulo 1000000009. For example, if Manao could obtain either 2000000000 or 2000000020 points, the answer is 2000000000 mod 1000000009, even though 2000000020 mod 1000000009 is a smaller number.


题目大意:有n道题,小明答对了m道,问他最少得多少分?得分规则,有一个计数器记录连着答对题目的数字,每连着答对k道题,那么当前分数*2,然后计数器清零,普通的+1。

解题思路:要求最少得分,那么应该使连着答对的都堆放在前面(因为*2后小,贪心),其余答对的都不让连着答对放在后面即可。

现在考虑前面,第一次连着答对k道题,那么此时得分为2k,继续连着答对k次,得分为(2k+k)*2=6k,继续连着答对k次,得分为(6k+k)*2=14k。。。发现规律第n次连着答对时得分为(2^(n+1)-2)*k,加上剩下的不连着答对的(m-连着答对次数*k)*1即可。

代码如下:

#include 
#define MOD 1000000009
#define LL long long
LL quickpow(LL a,LL b)  
{  
    LL ans=1;  
    LL base=a;  
    while(b)  
    {  
        if(b&1)  
        {  
            ans=(ans*base)%MOD;  
        }  
        base=(base*base)%MOD;  
        b>>=1;  
    }  
    return ans;  
}  
int main()
{
	LL n,m,k;
	while(scanf("%lld%lld%lld",&n,&m,&k)!=EOF)
	{
		LL cuo=n-m;//错误的题目数 
		LL kuai=n/k;//一共分成k块考虑 
		if(kuai<=cuo)//错误的多余分出的快数,说明每一块至少得错一道,不满足翻倍的条件 
		{
			printf("%lld\n",m%MOD);
		}
		else
		{
			LL ci=kuai-cuo;//翻倍的次数 
			LL ans=k*(quickpow(2,ci+1)-2)%MOD;//连着答对的总分 
			ans=(ans+m-ci*k+MOD)%MOD;//+MOD防止结果为负 *****这点wa了好几次。。。 
			printf("%lld\n",ans);
		}
	}
	return 0;
}



你可能感兴趣的:(思维,数学,规律,快速幂,思维,数学,规律,快速幂)